<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Scene Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_scene.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_scene-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Scene Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and control scenes from <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> and <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects.  
 <a href="class_scene.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_scene_8hpp_source.html">Scene.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad10176d75a9cc0da56626f682d083507"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene</a> ()</td></tr>
<tr class="memdesc:ad10176d75a9cc0da56626f682d083507"><td class="mdescLeft">&#160;</td><td class="mdescRight">A straighforward <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> constructor.  <a href="#ad10176d75a9cc0da56626f682d083507">More...</a><br /></td></tr>
<tr class="separator:ad10176d75a9cc0da56626f682d083507"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9c3da4fc4d5a31613601a23543abb92"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#af9c3da4fc4d5a31613601a23543abb92">getSurfacesVector</a> ()</td></tr>
<tr class="memdesc:af9c3da4fc4d5a31613601a23543abb92"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the vector of surfaces belonging to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>.  <a href="#af9c3da4fc4d5a31613601a23543abb92">More...</a><br /></td></tr>
<tr class="separator:af9c3da4fc4d5a31613601a23543abb92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acaf6d293b31f7ebcf20f1c9195ac4473"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#acaf6d293b31f7ebcf20f1c9195ac4473">getRootTransform</a> ()</td></tr>
<tr class="memdesc:acaf6d293b31f7ebcf20f1c9195ac4473"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to Root transform associated to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>. All transforms need to under (directly or by transitivity) the root transform.  <a href="#acaf6d293b31f7ebcf20f1c9195ac4473">More...</a><br /></td></tr>
<tr class="separator:acaf6d293b31f7ebcf20f1c9195ac4473"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2510b15715c974c567cffef03f1afa1f"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_light.html">Light</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a2510b15715c974c567cffef03f1afa1f">getLightsVector</a> ()</td></tr>
<tr class="memdesc:a2510b15715c974c567cffef03f1afa1f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the vector of Lights belonging to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>.  <a href="#a2510b15715c974c567cffef03f1afa1f">More...</a><br /></td></tr>
<tr class="separator:a2510b15715c974c567cffef03f1afa1f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e766a2cb866e58fb4e2d529b5937890"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_surface.html">Surface</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a6e766a2cb866e58fb4e2d529b5937890">surfaceFromID</a> (std::string _id)</td></tr>
<tr class="memdesc:a6e766a2cb866e58fb4e2d529b5937890"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the surface with a given ID.  <a href="#a6e766a2cb866e58fb4e2d529b5937890">More...</a><br /></td></tr>
<tr class="separator:a6e766a2cb866e58fb4e2d529b5937890"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf0478423fdf556ddb7759ad358e1597"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_triangle.html">Triangle</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#adf0478423fdf556ddb7759ad358e1597">triangleFromID</a> (std::string _id)</td></tr>
<tr class="memdesc:adf0478423fdf556ddb7759ad358e1597"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the triangle with a given ID.  <a href="#adf0478423fdf556ddb7759ad358e1597">More...</a><br /></td></tr>
<tr class="separator:adf0478423fdf556ddb7759ad358e1597"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0747eea84e4436d8f9a80e47ee1cfc66"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_sphere.html">Sphere</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a0747eea84e4436d8f9a80e47ee1cfc66">sphereFromID</a> (std::string _id)</td></tr>
<tr class="memdesc:a0747eea84e4436d8f9a80e47ee1cfc66"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the sphere with a given ID.  <a href="#a0747eea84e4436d8f9a80e47ee1cfc66">More...</a><br /></td></tr>
<tr class="separator:a0747eea84e4436d8f9a80e47ee1cfc66"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7dfd803c8a3e7c5379ec9866206b4f3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mesh.html">Mesh</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#ad7dfd803c8a3e7c5379ec9866206b4f3">meshFromID</a> (std::string _id)</td></tr>
<tr class="memdesc:ad7dfd803c8a3e7c5379ec9866206b4f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the mesh with a given ID.  <a href="#ad7dfd803c8a3e7c5379ec9866206b4f3">More...</a><br /></td></tr>
<tr class="separator:ad7dfd803c8a3e7c5379ec9866206b4f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add3094f0f28ce5af3ceba0c73332cff9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#add3094f0f28ce5af3ceba0c73332cff9">addSurface</a> (<a class="el" href="class_surface.html">Surface</a> *_surface, std::string _id)</td></tr>
<tr class="memdesc:add3094f0f28ce5af3ceba0c73332cff9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a surface to the scene and associates to it an ID (unique identifier).  <a href="#add3094f0f28ce5af3ceba0c73332cff9">More...</a><br /></td></tr>
<tr class="separator:add3094f0f28ce5af3ceba0c73332cff9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9ecf32c817a0b506a7bec7d0cca62993"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a9ecf32c817a0b506a7bec7d0cca62993">addSurface</a> (<a class="el" href="class_surface.html">Surface</a> *_surface)</td></tr>
<tr class="memdesc:a9ecf32c817a0b506a7bec7d0cca62993"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a surface to the scene.  <a href="#a9ecf32c817a0b506a7bec7d0cca62993">More...</a><br /></td></tr>
<tr class="separator:a9ecf32c817a0b506a7bec7d0cca62993"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60b89dee490379b29841bb89bdc2de4f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a60b89dee490379b29841bb89bdc2de4f">removeSurface</a> (int _index)</td></tr>
<tr class="memdesc:a60b89dee490379b29841bb89bdc2de4f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a surface from the scene, given its position in the vector of surfaces.  <a href="#a60b89dee490379b29841bb89bdc2de4f">More...</a><br /></td></tr>
<tr class="separator:a60b89dee490379b29841bb89bdc2de4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5715863fe55bc46732c50ffc496e0f33"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a5715863fe55bc46732c50ffc496e0f33">addLight</a> (<a class="el" href="class_light.html">Light</a> *_light)</td></tr>
<tr class="memdesc:a5715863fe55bc46732c50ffc496e0f33"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds a light source to the scene.  <a href="#a5715863fe55bc46732c50ffc496e0f33">More...</a><br /></td></tr>
<tr class="separator:a5715863fe55bc46732c50ffc496e0f33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58a0cf5a161223752ab530141dd67df7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a58a0cf5a161223752ab530141dd67df7">hit</a> (const <a class="el" href="class_ray.html">Ray</a> &amp;r, <a class="el" href="structhit__rec.html">hit_rec</a> &amp;h_r, double t_min, double t_max, <a class="el" href="class_surface.html">Surface</a> *light_geode)</td></tr>
<tr class="separator:a58a0cf5a161223752ab530141dd67df7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a428607516caaa0d83047574c4e77ce70"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_ray.html">Ray</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a428607516caaa0d83047574c4e77ce70">reflection</a> (<a class="el" href="class_ray.html">Ray</a> &amp;ray, <a class="el" href="structhit__rec.html">hit_rec</a> h_r)</td></tr>
<tr class="memdesc:a428607516caaa0d83047574c4e77ce70"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a reflection <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>, given an incinding <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> and corresponding surface-hit record.  <a href="#a428607516caaa0d83047574c4e77ce70">More...</a><br /></td></tr>
<tr class="separator:a428607516caaa0d83047574c4e77ce70"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6849be73b0e7e50ec55d1e7a8d0c1ec4"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_ray.html">Ray</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a6849be73b0e7e50ec55d1e7a8d0c1ec4">refraction</a> (<a class="el" href="class_ray.html">Ray</a> &amp;ray, <a class="el" href="structhit__rec.html">hit_rec</a> h_r, double &amp;R)</td></tr>
<tr class="memdesc:a6849be73b0e7e50ec55d1e7a8d0c1ec4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a refraction <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>, given an incinding <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> and corresponding surface-hit record.  <a href="#a6849be73b0e7e50ec55d1e7a8d0c1ec4">More...</a><br /></td></tr>
<tr class="separator:a6849be73b0e7e50ec55d1e7a8d0c1ec4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa164a99f7b7b95f91ad96c065da409d5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#aa164a99f7b7b95f91ad96c065da409d5">transform</a> ()</td></tr>
<tr class="memdesc:aa164a99f7b7b95f91ad96c065da409d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the application of all transforms defined for all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> and <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects with setTransform()  <a href="#aa164a99f7b7b95f91ad96c065da409d5">More...</a><br /></td></tr>
<tr class="separator:aa164a99f7b7b95f91ad96c065da409d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d206b4dd94733867c8f07834319a2a1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a9d206b4dd94733867c8f07834319a2a1">setBVH</a> ()</td></tr>
<tr class="separator:a9d206b4dd94733867c8f07834319a2a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a0196c28bebf7f0cd29345066887ac4f1"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a0196c28bebf7f0cd29345066887ac4f1">surfaces</a></td></tr>
<tr class="memdesc:a0196c28bebf7f0cd29345066887ac4f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector containing pointers to all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> objects that are to be rendered.  <a href="#a0196c28bebf7f0cd29345066887ac4f1">More...</a><br /></td></tr>
<tr class="separator:a0196c28bebf7f0cd29345066887ac4f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6fc93379440340cecd060235a1b9f69a"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a6fc93379440340cecd060235a1b9f69a">objects</a></td></tr>
<tr class="memdesc:a6fc93379440340cecd060235a1b9f69a"><td class="mdescLeft">&#160;</td><td class="mdescRight">An internal structure (do not use it).  <a href="#a6fc93379440340cecd060235a1b9f69a">More...</a><br /></td></tr>
<tr class="separator:a6fc93379440340cecd060235a1b9f69a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a979988030703212b02a2ce950b5ed0a6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a979988030703212b02a2ce950b5ed0a6">root_tf</a></td></tr>
<tr class="separator:a979988030703212b02a2ce950b5ed0a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45b8655cf456ce0383290db41f2b7c0b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_b_v_h.html">BVH</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a45b8655cf456ce0383290db41f2b7c0b">bvh</a></td></tr>
<tr class="memdesc:a45b8655cf456ce0383290db41f2b7c0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">The bounding volume hierarchy object.  <a href="#a45b8655cf456ce0383290db41f2b7c0b">More...</a><br /></td></tr>
<tr class="separator:a45b8655cf456ce0383290db41f2b7c0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ecc3182a80435e1c4dfbe1b20e559bd"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_light.html">Light</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_scene.html#a4ecc3182a80435e1c4dfbe1b20e559bd">lights</a></td></tr>
<tr class="memdesc:a4ecc3182a80435e1c4dfbe1b20e559bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector containing pointers to all <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects to be used while rendering.  <a href="#a4ecc3182a80435e1c4dfbe1b20e559bd">More...</a><br /></td></tr>
<tr class="separator:a4ecc3182a80435e1c4dfbe1b20e559bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and control scenes from <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> and <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad10176d75a9cc0da56626f682d083507"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad10176d75a9cc0da56626f682d083507">&sect;&nbsp;</a></span>Scene()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Scene::Scene </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A straighforward <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a5715863fe55bc46732c50ffc496e0f33"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5715863fe55bc46732c50ffc496e0f33">&sect;&nbsp;</a></span>addLight()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Scene::addLight </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>_light</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds a light source to the scene. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_surface</td><td>Pointer to the light source to be appended. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="add3094f0f28ce5af3ceba0c73332cff9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add3094f0f28ce5af3ceba0c73332cff9">&sect;&nbsp;</a></span>addSurface() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Scene::addSurface </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_surface.html">Surface</a> *&#160;</td>
          <td class="paramname"><em>_surface</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds a surface to the scene and associates to it an ID (unique identifier). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_surface</td><td>Pointer to the surface to be appended. </td></tr>
    <tr><td class="paramname">_id</td><td>The ID to be associated to the surface. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9ecf32c817a0b506a7bec7d0cca62993"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9ecf32c817a0b506a7bec7d0cca62993">&sect;&nbsp;</a></span>addSurface() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Scene::addSurface </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_surface.html">Surface</a> *&#160;</td>
          <td class="paramname"><em>_surface</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds a surface to the scene. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_surface</td><td>Pointer to the surface to be appended. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2510b15715c974c567cffef03f1afa1f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2510b15715c974c567cffef03f1afa1f">&sect;&nbsp;</a></span>getLightsVector()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_light.html">Light</a>*&gt;* Scene::getLightsVector </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the vector of Lights belonging to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>. </p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the vector of lights belonging to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>. </dd></dl>

</div>
</div>
<a id="acaf6d293b31f7ebcf20f1c9195ac4473"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acaf6d293b31f7ebcf20f1c9195ac4473">&sect;&nbsp;</a></span>getRootTransform()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_transform.html">Transform</a>* Scene::getRootTransform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to Root transform associated to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>. All transforms need to under (directly or by transitivity) the root transform. </p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to Root transform. </dd></dl>

</div>
</div>
<a id="af9c3da4fc4d5a31613601a23543abb92"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af9c3da4fc4d5a31613601a23543abb92">&sect;&nbsp;</a></span>getSurfacesVector()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_surface.html">Surface</a>*&gt;* Scene::getSurfacesVector </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the vector of surfaces belonging to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>. </p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the vector of surfaces belonging to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a>. </dd></dl>

</div>
</div>
<a id="a58a0cf5a161223752ab530141dd67df7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a58a0cf5a161223752ab530141dd67df7">&sect;&nbsp;</a></span>hit()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Scene::hit </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a> &amp;&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_max</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_surface.html">Surface</a> *&#160;</td>
          <td class="paramname"><em>light_geode</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Triggers the intersection tests over all geometry contained in this scene and a given <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>. Each <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> is responsible for its own intersection test.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">r</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> to be tested </td></tr>
    <tr><td class="paramname">h_r</td><td>hit record that stores the information regarding the first intersection between r and the scene's geometry </td></tr>
    <tr><td class="paramname">t_min</td><td>controls the closest allowed intersection </td></tr>
    <tr><td class="paramname">t_max</td><td>controls the furthest allowed intersection </td></tr>
    <tr><td class="paramname">light_geode</td><td>Pointer to a <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> object associated to the <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> source and, so, that shall not be included in the intersection tests. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad7dfd803c8a3e7c5379ec9866206b4f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad7dfd803c8a3e7c5379ec9866206b4f3">&sect;&nbsp;</a></span>meshFromID()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mesh.html">Mesh</a> * Scene::meshFromID </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a pointer to the mesh with a given ID. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>The ID of the mesh to be returned. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the mesh. </dd></dl>

</div>
</div>
<a id="a428607516caaa0d83047574c4e77ce70"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a428607516caaa0d83047574c4e77ce70">&sect;&nbsp;</a></span>reflection()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_ray.html">Ray</a> Scene::reflection </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>ray</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a>&#160;</td>
          <td class="paramname"><em>h_r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a reflection <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>, given an incinding <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> and corresponding surface-hit record. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ray</td><td>incinding <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> </td></tr>
    <tr><td class="paramname">h_r</td><td>hit record </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>reflection <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> </dd></dl>

</div>
</div>
<a id="a6849be73b0e7e50ec55d1e7a8d0c1ec4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6849be73b0e7e50ec55d1e7a8d0c1ec4">&sect;&nbsp;</a></span>refraction()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_ray.html">Ray</a> Scene::refraction </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>ray</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a>&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double &amp;&#160;</td>
          <td class="paramname"><em>R</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a refraction <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>, given an incinding <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> and corresponding surface-hit record. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ray</td><td>incinding <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> </td></tr>
    <tr><td class="paramname">h_r</td><td>hit record </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>refraction <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> </dd></dl>

</div>
</div>
<a id="a60b89dee490379b29841bb89bdc2de4f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a60b89dee490379b29841bb89bdc2de4f">&sect;&nbsp;</a></span>removeSurface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Scene::removeSurface </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Removes a surface from the scene, given its position in the vector of surfaces. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_index</td><td>The position of the surface to be removed in the vector of surfaces. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9d206b4dd94733867c8f07834319a2a1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9d206b4dd94733867c8f07834319a2a1">&sect;&nbsp;</a></span>setBVH()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Scene::setBVH </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a0747eea84e4436d8f9a80e47ee1cfc66"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0747eea84e4436d8f9a80e47ee1cfc66">&sect;&nbsp;</a></span>sphereFromID()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_sphere.html">Sphere</a> * Scene::sphereFromID </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a pointer to the sphere with a given ID. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>The ID of the sphere to be returned. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the sphere. </dd></dl>

</div>
</div>
<a id="a6e766a2cb866e58fb4e2d529b5937890"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6e766a2cb866e58fb4e2d529b5937890">&sect;&nbsp;</a></span>surfaceFromID()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_surface.html">Surface</a> * Scene::surfaceFromID </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a pointer to the surface with a given ID. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>The ID of the surface to be returned. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the surface. </dd></dl>

</div>
</div>
<a id="aa164a99f7b7b95f91ad96c065da409d5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa164a99f7b7b95f91ad96c065da409d5">&sect;&nbsp;</a></span>transform()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Scene::transform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Triggers the application of all transforms defined for all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> and <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects with setTransform() </p>

</div>
</div>
<a id="adf0478423fdf556ddb7759ad358e1597"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf0478423fdf556ddb7759ad358e1597">&sect;&nbsp;</a></span>triangleFromID()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_triangle.html">Triangle</a> * Scene::triangleFromID </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a pointer to the triangle with a given ID. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>The ID of the triangle to be returned. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the triangle. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a45b8655cf456ce0383290db41f2b7c0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a45b8655cf456ce0383290db41f2b7c0b">&sect;&nbsp;</a></span>bvh</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_b_v_h.html">BVH</a> Scene::bvh</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The bounding volume hierarchy object. </p>

</div>
</div>
<a id="a4ecc3182a80435e1c4dfbe1b20e559bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4ecc3182a80435e1c4dfbe1b20e559bd">&sect;&nbsp;</a></span>lights</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_light.html">Light</a>*&gt; Scene::lights</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Vector containing pointers to all <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects to be used while rendering. </p>

</div>
</div>
<a id="a6fc93379440340cecd060235a1b9f69a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6fc93379440340cecd060235a1b9f69a">&sect;&nbsp;</a></span>objects</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_surface.html">Surface</a>*&gt; Scene::objects</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>An internal structure (do not use it). </p>

</div>
</div>
<a id="a979988030703212b02a2ce950b5ed0a6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a979988030703212b02a2ce950b5ed0a6">&sect;&nbsp;</a></span>root_tf</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_transform.html">Transform</a> Scene::root_tf</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The root transform node. All transforms that are not child from any other, must be made child of the root_tf. </p>

</div>
</div>
<a id="a0196c28bebf7f0cd29345066887ac4f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0196c28bebf7f0cd29345066887ac4f1">&sect;&nbsp;</a></span>surfaces</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_surface.html">Surface</a>*&gt; Scene::surfaces</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Vector containing pointers to all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> objects that are to be rendered. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_scene_8hpp_source.html">Scene.hpp</a></li>
<li>src/<a class="el" href="_scene_8cpp.html">Scene.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_scene.html">Scene</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
